; -----------------------------------------------
; FireGDI+: original algos in VB6 by Cicri
; enhanced using GDIplus.dll in VB6 by Phoenix
; Ported to asm by Phoenix - 
; finished on 12/24/2004 (just before Santa Claus
; came to my children :-) 
; -----------------------------------------------

Include GDIplus_V0a.inc
Include gdiplus_structures_ver0.inc
IncludeLib gdiplus.lib

DrawProc PROTO :DWORD
_nrandom2 PROTO :DWORD

.DATA

szGDIpInitOK	DB "GDIplus initialized",0
szGDIpInitFail	DB "GDIplus.dll not found",0
szWtFileName	DB "GDIplusData.bin",0
GdiPlusSI 		GdiplusStartupInput	<1,NULL,FALSE,FALSE> ;default
hLMem			DWORD 0
hLColMem		DWORD 0
rct				RECT <0,0,0,0>		; Client Rect of window
oldRct			RECT <0,0,-1,-1>	; needed to recognize changes

drawFlag		DWORD TRUE
seed 			DWORD 12345678
elTime			DWORD 0
pWidth			REAL10 8.0

.DATA?

hGDIplus 		DWORD ?			; token
ptrColTable		DWORD ?			; ptr to colortable (1024 bytes)
lBuf			DWORD ?
szBuf			DB 256 DUP (?)

.CODE

TimerProc proc hWnd:DWORD, uMsg:DWORD, idEvent:DWORD, dwTime:DWORD

Local graphics:DWORD
local bitmap:DWORD
Local bmpData:BitmapData
Local lineOffset:DWORD
Local colOffset

;	Invoke GetTickCount
;	mov elTime,eax
	; -----------------------------------------------
	; allocate memory for color-indexes if needed
	; -----------------------------------------------
	mov drawFlag,TRUE
	Invoke GetClientRect,hWnd,ADDR rct
	mov eax,rct.right
	mov ecx,rct.bottom
	.IF eax != oldRct.right || ecx != oldRct.bottom ; Window size was changed
		.IF eax == 0 || ecx == 0					; no drawable area (i. e. minimized)
			mov drawFlag,FALSE						; prevent drawing	
		.ELSE
			mov oldRct.bottom,ecx									
			mov oldRct.right,eax					; remember new dimensions
			mul ecx									; get number of pixels
			shl eax,2								; 4 bytes per pixel
			push eax 
			.IF hLColMem != 0						; check if we have a valid handle
				Invoke LocalFree,hLColMem			; free allocated memory
				mov hLColMem,eax
			.ENDIF
			pop eax
			Invoke LocalAlloc,LMEM_FIXED OR LMEM_ZEROINIT,eax
			mov hLColMem,eax
		.ENDIF
	.ENDIF
	
	; drawing allowed?
	.IF drawFlag == FALSE
		XOR eax,eax
		RET
	.ENDIF
	
	Invoke GdipCreateFromHWND,hWnd,ADDR graphics
	;Invoke GdipSetCompositingMode, graphics, CompositingModeSourceOver
	Invoke GdipCreateBitmapFromGraphics,rct.right,rct.bottom,graphics,ADDR bitmap
	Invoke GdipBitmapLockBits,bitmap,DWORD PTR rct,ImageLockModeWrite,PixelFormat32bppPARGB,ADDR bmpData
	; -----------------------------------------------
	; Fill 3 bottom lines with random colors
	; -----------------------------------------------
	mov ecx,rct.bottom
	sub ecx,3
	.WHILE ecx < rct.bottom		; Height
	push ecx
		mov eax,ecx
		mul bmpData.stride			; (y * stride)
		mov lineOffset,eax
		xor edx,edx
		.WHILE edx < rct.right 		; Width
		push edx
			push edx
			Invoke _nrandom2,26		; Get random color index
			add eax,80
			; Calculate address of pixel to modify
			;[Scan0+(y * stride)+(x*4)]
			pop edx
			shl edx,2				; (x*4)
			add edx,lineOffset		; (y * stride)+(x*4)
			mov ecx,hLColMem		; hLColMem+(y * stride)+(x*4)
			mov [ecx+edx],eax		; store color index
		pop edx
		inc edx
		.ENDW
	pop ecx
	inc ecx
	.ENDW
	; -----------------------------------------------
	; calculate line offset for random hot spots
	; -----------------------------------------------
	mov eax,rct.bottom
	sub eax,3				; top line to place hot spots
	mul bmpData.stride		; (y * stride) calculate line offset
	mov lineOffset,eax		; store line offset
	; -----------------------------------------------
	; Calculate number of hot spots from 0 to width/8
	; -----------------------------------------------
	mov eax,rct.right
	shr eax,3					; divide by 8 
	Invoke _nrandom2,eax
	mov	ecx,eax
	; -----------------------------------------------
	; Add random hot spots, 3x3 pixel
	; -----------------------------------------------
	.WHILE ecx > 0
	push ecx
		; calculate random position for hot spots
		mov eax,rct.right		; width of client rect
		sub eax,3
		Invoke _nrandom2,eax	; get random position
		inc eax					; correct offset
		shl eax,2				; (x*4)
		mov edx,0ffh			; index 255 = "hottest" pixel color
		add eax,lineOffset		; (y*stride)+(x*4)
		add eax,hLColMem		; ptr to colormap
		mov	[eax-4],edx
		mov	[eax],edx
		mov	[eax+4],edx
		add eax,bmpData.stride
		mov	[eax-4],edx
		mov	[eax],edx
		mov	[eax+4],edx
		add eax,bmpData.stride
		mov	[eax-4],edx
		mov	[eax],edx
		mov	[eax+4],edx	
	pop ecx
	dec ecx
	.ENDW
	
	mov ecx,3
	sub rct.right,ecx
	sub rct.bottom,ecx
	; -----------------------------------------------
	; Calculate each pixel based on 8 neighbors
	; -----------------------------------------------
	sub ecx,2
	.WHILE ecx < rct.right
	push ecx
		shl ecx,2	; (x*4)	
		mov colOffset,ecx
		
		mov edx,rct.bottom
		sub edx,130
		.WHILE edx < rct.bottom
		push edx
			finit
			mov eax,edx
			add eax,2
			push  eax				; place for return value of FPU
			fld pWidth
			mul bmpData.stride		; (y * stride)
			mov edx,eax
			add edx,colOffset		; (y * stride)+(x*4)
			mov ecx,hLColMem
			fild DWORD PTR [ecx+edx-4]
			fiadd DWORD PTR [ecx+edx]
			fiadd DWORD PTR [ecx+edx+4]
			sub edx,bmpData.stride
			fiadd DWORD PTR [ecx+edx-4]
			fiadd DWORD PTR [ecx+edx]
			fiadd DWORD PTR [ecx+edx+4]			
			sub edx,bmpData.stride
			fiadd DWORD PTR [ecx+edx-4]
			fiadd DWORD PTR [ecx+edx+4]						
			fdiv st,st(1)
			fist DWORD PTR [esp]
			pop eax
			test eax,eax		; is result zero?
			jz _isNull			; no need to write value
			dec eax				; decrease pixels temperature 
			mov [ecx+edx],eax	; store in pixels array
			shl eax,2			; multiply by 4 to get color offset
			mov ecx,ptrColTable ; get corresponding color
			mov eax,[ecx+eax]
			mov ecx,bmpData.scan0
			mov [ecx+edx],eax
_isNull:	
		pop edx
		inc edx
		.ENDW
	pop ecx
	inc ecx
	.ENDW
	
	Invoke GdipBitmapUnlockBits,bitmap,ADDR bmpData
	Invoke GdipDrawImage,graphics,bitmap,0,0
	
	Invoke GdipDisposeImage,bitmap
	Invoke GdipDeleteGraphics,graphics
	
;	Invoke GetTickCount
;	sub eax,elTime
;	Invoke dwtoa,eax,ADDR szBuf
;	Invoke SetWindowText,hWnd,ADDR szBuf
	XOR eax,eax 
	RET
TimerProc ENDP

_nrandom2 PROC base:DWORD
    mov eax, seed
    xor edx, edx

    ; Moved to avoid unnecessary dependency.
    ;****************************************
    test eax, 80000000h
    jz  @F
    add eax, 7fffffffh
  @@:
    ;****************************************

    mov ecx, 127773
    div ecx
    mov ecx, eax
    mov eax, 16807
    mul edx
    mov edx, ecx
    mov ecx, eax
    mov eax, 2836
    mul edx
    sub ecx, eax
    xor edx, edx
    mov eax, ecx
    mov seed, ecx

    ;*******************************
    ;div base
    shl eax,1
    mul base
    ;*******************************

    mov eax, edx
    ret
_nrandom2 ENDP

initColorTable PROC 

        push    ebx                 ; save the ebx value
        push    ebp                 ; save the ebp value
        push    edi                 ; save the edi value
        push    esi                 ; save the esi value
    
        mov     ebp,ptrColTable     ; get Pointer to Colortable
        
        xor     edx,edx             ; clear edx
        not     edx                 ; set edx to 0ffffffffh
        mov     ebx,40              ; 10*4
    _Loop1:                         ; 10 times
        mov     edi,ebp
        add     edi,ebx                   
        mov     BYTE Ptr [edi+3],dl ; alpha byte
        mov     eax,ebx     
        add     eax,eax             ; multiply by 2 = blue byte
        mov     BYTE Ptr [edi],al   ; blue byte
        sub     ebx,4
        jns     _Loop1

        mov     ebx,40              ; 10*4
    _Loop2:                         ; 10 times
        mov     edi,ebp
        add     edi,ebx
        add     edi,40                   
        mov     BYTE Ptr [edi+3],dl ; alpha byte
        mov     eax,ebx
        add     eax,eax
        mov     BYTE Ptr [edi+2],al ; red byte 
        mov     cl,050h
        mov     eax,ebx
        add     eax,eax
        sub     ecx,eax
        mov     BYTE Ptr [edi],cl   ; blue byte
        sub     ebx,4
        jns     _Loop2

        add     ebx,88              ; 21*4 + 4
        mov     ecx,82
    _Loop3:                         ; 21 times
        mov     edi,ebp
        add     edi,ebx
        add     edi,ecx
        mov     BYTE Ptr [edi+1],dl ; alpha byte
        mov     eax,ebx
        add     eax,40
        add     eax,eax
        mov     BYTE Ptr [edi],al   ; red byte 
        sub     ebx,4
        jns     _Loop3

        mov     ebx,124             ; 32*4
        mov     ecx,170
    _Loop4:                         ; 32 times
        mov     edi,ebp
        add     edi,ebx
        add     edi,ecx
        mov     WORD Ptr [edi],dx   ; alpha+red byte
        mov     eax,ebx
        add     eax,eax
        mov     BYTE Ptr [edi-1],al ; green byte
        sub     ebx,4
        jns     _Loop4

        mov     ebx,124             ; 32*4
        mov     ecx,296
    _Loop5:                         ; 32 times
        mov     edi,ebp
        add     edi,ebx
        add     edi,ecx
        mov     [edi],edx
        mov     eax,ebx
        add     eax,eax
        mov     BYTE Ptr [edi],al  ; blue byte
        sub     ebx,4
        jns     _Loop5

        mov     ebx,424            ; 106*4
        mov     ecx,25             ; buffer size in dwords (6 dwords per loop)
    _loop6:
        mov     edi,ebp            ; ptr to array
        add     edi,ebx            ; add offset
        mov     [edi],edx
        mov     [edi+4],edx
        mov     [edi+8],edx
        mov     [edi+12],edx
        mov     [edi+16],edx
        mov     [edi+20],edx        
        add     ebx,24
        dec     ecx
        jnz     _loop6
        
        xor     eax,eax            ; 0 = ok 
        
        pop     esi                ; restore the esi value
        pop     edi                ; restore the edi value
        pop     ebp                ; restore the ebp value
        pop     ebx                ; restore the ebx value
        ret                        ; return eax
       
initColorTable ENDP

dwtoa PROC dwValue:DWORD, lpBuffer:DWORD

    ; -------------------------------------------------------------
    ; convert DWORD to ascii string
    ; dwValue is value to be converted
    ; lpBuffer is the address of the receiving buffer
    ; EXAMPLE:
    ; Invoke dwtoa,edx,ADDR buffer
    ;
    ; Uses: eax, ecx, edx.
    ; -------------------------------------------------------------

    push ebx
    push esi
    push edi

    mov eax, dwValue
    mov edi, [lpBuffer]

    or eax,eax
    jnz sign

  zero:
    mov word ptr [edi],30h
    ret

  sign:
    jns pos
    mov byte ptr [edi],'-'
    neg eax
    inc edi

  pos:
    mov ecx, 3435973837
    mov esi, edi

    .WHILE (eax > 0)
      mov ebx,eax
      mul ecx
      shr edx, 3
      mov eax,edx
      lea edx,[edx*4+edx]
      add edx,edx
      sub ebx,edx
      add bl,'0'
      mov [edi],bl
      inc edi
    .ENDW

    mov byte ptr [edi], 0       ; terminate the string

    ; We now have all the digits, but in reverse order.

    .WHILE (esi < edi)
      dec edi
      mov al, [esi]
      mov ah, [edi]
      mov [edi], al
      mov [esi], ah
      inc esi
    .ENDW

    pop edi
    pop esi
    pop ebx
    ret

dwtoa ENDP
